/**********************************************************************
** Copyright (C) 2002 Trolltech AS.  All rights reserved.
**
** This file is part of TQt Designer.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** Licensees holding valid TQt Enterprise Edition or TQt Professional Edition
** licenses may use this file in accordance with the TQt Commercial License
** Agreement provided with the Software.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/gpl/ for GPL licensing information.
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
**   information about TQt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

#ifndef LISTVIEWDND_H
#define LISTVIEWDND_H

#include <tqptrlist.h>
#include <tqlistview.h>
#include "listdnd.h"

class TQWidget;
class TQListView;
typedef TQPtrList<TQListViewItem> ListViewItemList;

class ListViewDnd : public ListDnd
{
    Q_OBJECT
  
public:
    enum DragMode { Flat = 16 }; // see ListDnd::DragMode

    ListViewDnd( TQListView * eventSource, const char * name = 0 );

signals:
    void dropped( TQListViewItem * );

public slots:
    void confirmDrop( TQListViewItem * );

protected:
    virtual bool dropEvent( TQDropEvent * event );
    virtual bool mouseMoveEvent( TQMouseEvent * event );
    virtual void updateLine( const TQPoint & pos );
    virtual bool canDecode( TQDragEnterEvent * event );
private:
    TQListViewItem * itemAt( TQPoint pos );
    int dropDepth( TQListViewItem * item, TQPoint pos );
    int buildFlatList( ListViewItemList & list );
    int buildTreeList( ListViewItemList & list );
    void setVisibleItems( bool b );
    ListViewItemList disabledItems;
};

#endif //LISTVIEWDND_H
